! anginterp.f90
! Interpolate an angle (and beware of the (0, 2pi> interval).

FUNCTION AngInterp(time, t_0, t_1, A_0, A_1)

implicit none
real*8 time, t_0, t_1, A_0, A_1
real*8 AngInterp
real*8, parameter :: pi = 3.1415926d0
real*8 zero2pi


IF ((A_1-A_0).GT.pi)    A_0 = A_0 + 2.d0*pi
IF ((A_1-A_0).LT.(-pi)) A_0 = A_0 - 2.d0*pi

AngInterp = zero2pi(A_0 + (time - t_0)*(A_1 - A_0)/(t_1 - t_0))

END FUNCTION

