! get_elements.f90
! Get orbital elements for planets - interpolate the array stored in memory.

SUBROUTINE GetElements(time, planet, mass, nbod, a, e, inc, capom, omega, capm) 

implicit none
real*8 time 
integer planet, nbod
real*8 mass(nbod)
real*8 a, e, inc, capom, omega, capm

! internals
integer i
real*8 t_0, t_1, t_step, t_min, capm_0

integer idx
real*8 time_old
save idx, time_old
data idx /1/
data time_old /-1.d0/

! functions
real*8 zero2pi, AngInterp, Interp

include 'elements.inc'

if (abs(time-time_old).gt.1.d-3) then
!  idx = 1	! BEWARE OF THIS, IT SLOWS DOWN THE CODE!!!
  do while ((times_pl(idx).lt.time).and.(idx.le.times_pl_n-1))
    idx = idx+1
  enddo
  idx = idx-1
  time_old = time
!  write(*,*) "time = ", time/365.25d6, " Myr, idx = ", idx	! dbg
endif

t_0 = times_pl(idx)
t_1 = times_pl(idx+1)

a   = Interp(time, t_0, t_1, elmts_pl(idx, planet, 1), elmts_pl(idx+1, planet, 1))
e   = Interp(time, t_0, t_1, elmts_pl(idx, planet, 2), elmts_pl(idx+1, planet, 2))
inc = Interp(time, t_0, t_1, elmts_pl(idx, planet, 3), elmts_pl(idx+1, planet, 3))

capom = AngInterp(time, t_0, t_1, elmts_pl(idx, planet, 4), elmts_pl(idx+1, planet, 4))
omega = AngInterp(time, t_0, t_1, elmts_pl(idx, planet, 5), elmts_pl(idx+1, planet, 5)) 

capm_0 = elmts_pl(idx, planet, 6)
capm = zero2pi(capm_0 + elmts_pl(idx, planet, 7)*(time - t_0))

END SUBROUTINE
